<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>Communication Protocol</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<table width=100%>
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border=0 src="../../tilogo.gif"></a></td>
  <td bgcolor="red"><img src="../../titagline.gif"></td>
</tr>
</table>
<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Communication Protocol</div>  </div>
</div><!--header-->
<div class="contents">

<p>mmwave Communication Driver Module  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:gacaf1e6cb030df5515de84b341558d28c"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gacaf1e6cb030df5515de84b341558d28c">rlDriverOsiInit</a> (void)</td></tr>
<tr class="memdesc:gacaf1e6cb030df5515de84b341558d28c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initializes the OSI layer abstraction for mmwavelink.  <a href="#gacaf1e6cb030df5515de84b341558d28c">More...</a><br /></td></tr>
<tr class="separator:gacaf1e6cb030df5515de84b341558d28c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga01309c1d2f30754b6d5aa89dc1534255"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga01309c1d2f30754b6d5aa89dc1534255">rlDriverAddDevice</a> (rlUInt8_t deviceMap)</td></tr>
<tr class="memdesc:ga01309c1d2f30754b6d5aa89dc1534255"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds mmwave radar device.  <a href="#ga01309c1d2f30754b6d5aa89dc1534255">More...</a><br /></td></tr>
<tr class="separator:ga01309c1d2f30754b6d5aa89dc1534255"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga345ace252f9c3676e09abc0f0b01ad4f"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga345ace252f9c3676e09abc0f0b01ad4f">rlDriverRemoveDevices</a> (rlUInt8_t deviceMap)</td></tr>
<tr class="memdesc:ga345ace252f9c3676e09abc0f0b01ad4f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Disconnects the mmwave radar devices.  <a href="#ga345ace252f9c3676e09abc0f0b01ad4f">More...</a><br /></td></tr>
<tr class="separator:ga345ace252f9c3676e09abc0f0b01ad4f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaaea65220c5b45aa33f34cf850e2525e6"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gaaea65220c5b45aa33f34cf850e2525e6">rlDriverDeInit</a> (void)</td></tr>
<tr class="memdesc:gaaea65220c5b45aa33f34cf850e2525e6"><td class="mdescLeft">&#160;</td><td class="mdescRight">De Initializes the mmwave radar Driver.  <a href="#gaaea65220c5b45aa33f34cf850e2525e6">More...</a><br /></td></tr>
<tr class="separator:gaaea65220c5b45aa33f34cf850e2525e6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8e9911b7e730e53f84b06aaa40ed12d2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structrl_driver_data__t.html">rlDriverData_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga8e9911b7e730e53f84b06aaa40ed12d2">rlDriverGetHandle</a> (void)</td></tr>
<tr class="memdesc:ga8e9911b7e730e53f84b06aaa40ed12d2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns mmwave radar Driver Global Structure.  <a href="#ga8e9911b7e730e53f84b06aaa40ed12d2">More...</a><br /></td></tr>
<tr class="separator:ga8e9911b7e730e53f84b06aaa40ed12d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad528c852d8412ce65b201070852cea98"><td class="memItemLeft" align="right" valign="top">rlUInt8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gad528c852d8412ce65b201070852cea98">rlDriverGetPlatformId</a> (void)</td></tr>
<tr class="memdesc:gad528c852d8412ce65b201070852cea98"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns RL Platform ID (i.e. where mmWaveLink is executing)  <a href="#gad528c852d8412ce65b201070852cea98">More...</a><br /></td></tr>
<tr class="separator:gad528c852d8412ce65b201070852cea98"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad308ecd31e0d11005e2726295c713e05"><td class="memItemLeft" align="right" valign="top">rlUInt8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gad308ecd31e0d11005e2726295c713e05">rlDriverGetArDeviceType</a> (void)</td></tr>
<tr class="memdesc:gad308ecd31e0d11005e2726295c713e05"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns AR device type which mmWavelink is communicating.  <a href="#gad308ecd31e0d11005e2726295c713e05">More...</a><br /></td></tr>
<tr class="separator:gad308ecd31e0d11005e2726295c713e05"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab8128bc740cbb6aea32dc2d0145517fc"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gab8128bc740cbb6aea32dc2d0145517fc">rlDriverIsDeviceMapValid</a> (rlUInt8_t deviceMap)</td></tr>
<tr class="memdesc:gab8128bc740cbb6aea32dc2d0145517fc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if given deviecMap is valid wrt to global DeviceMap set to mmWaveLink.  <a href="#gab8128bc740cbb6aea32dc2d0145517fc">More...</a><br /></td></tr>
<tr class="separator:gab8128bc740cbb6aea32dc2d0145517fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga62c0e0b554649602ff54d2619f368a4d"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga62c0e0b554649602ff54d2619f368a4d">rlDriverWaitForResponse</a> (rlUInt8_t devIndex, <a class="el" href="structrl_driver_msg__t.html">rlDriverMsg_t</a> *outMsg)</td></tr>
<tr class="memdesc:ga62c0e0b554649602ff54d2619f368a4d"><td class="mdescLeft">&#160;</td><td class="mdescRight">: Wait for Device's response  <a href="#ga62c0e0b554649602ff54d2619f368a4d">More...</a><br /></td></tr>
<tr class="separator:ga62c0e0b554649602ff54d2619f368a4d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3b6ed9a21f83053d4472bfa2dd4edeb3"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga3b6ed9a21f83053d4472bfa2dd4edeb3">rlDriverCmdInvoke</a> (rlUInt8_t deviceMap, <a class="el" href="structrl_driver_msg__t.html">rlDriverMsg_t</a> inMsg, <a class="el" href="structrl_driver_msg__t.html">rlDriverMsg_t</a> *outMsg)</td></tr>
<tr class="memdesc:ga3b6ed9a21f83053d4472bfa2dd4edeb3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Invokes a command to mmwave radar Device. Implements mmwave radar Host Communication Protocol(RHCP)  <a href="#ga3b6ed9a21f83053d4472bfa2dd4edeb3">More...</a><br /></td></tr>
<tr class="separator:ga3b6ed9a21f83053d4472bfa2dd4edeb3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaad8c54c2f6a875873d3e8d5c4bbb4996"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gaad8c54c2f6a875873d3e8d5c4bbb4996">rlDriverConfigureCrc</a> (rlCrcType_t crcType)</td></tr>
<tr class="memdesc:gaad8c54c2f6a875873d3e8d5c4bbb4996"><td class="mdescLeft">&#160;</td><td class="mdescRight">Configures the CRC Type in mmwavelink Driver.  <a href="#gaad8c54c2f6a875873d3e8d5c4bbb4996">More...</a><br /></td></tr>
<tr class="separator:gaad8c54c2f6a875873d3e8d5c4bbb4996"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga84ada376a4dd043625af0c74f5949139"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga84ada376a4dd043625af0c74f5949139">rlDriverConfigureAckTimeout</a> (rlUInt32_t ackTimeout)</td></tr>
<tr class="memdesc:ga84ada376a4dd043625af0c74f5949139"><td class="mdescLeft">&#160;</td><td class="mdescRight">Configures the Acknowledgement timeout in mmwavelink Driver.  <a href="#ga84ada376a4dd043625af0c74f5949139">More...</a><br /></td></tr>
<tr class="separator:ga84ada376a4dd043625af0c74f5949139"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadb76873c3994b89f576431bfd4a4322f"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gadb76873c3994b89f576431bfd4a4322f">rlDriverCalCRC</a> (rlUInt8_t *data, rlUInt16_t dataLen, rlUInt8_t crcType, rlUInt8_t crc[RL_CRC_LEN_MAX])</td></tr>
<tr class="memdesc:gadb76873c3994b89f576431bfd4a4322f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculates 16bit/32bit/64bit CRC.  <a href="#gadb76873c3994b89f576431bfd4a4322f">More...</a><br /></td></tr>
<tr class="separator:gadb76873c3994b89f576431bfd4a4322f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga86991d60ebe2ff23303e2a6ced1273f6"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga86991d60ebe2ff23303e2a6ced1273f6">rlDriverVerifyCRC</a> (rlUInt8_t *data, rlUInt16_t dataLen, rlUInt8_t crcType, rlUInt8_t crc[RL_CRC_LEN_MAX])</td></tr>
<tr class="memdesc:ga86991d60ebe2ff23303e2a6ced1273f6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compares received CRC with Calculated CRC.  <a href="#ga86991d60ebe2ff23303e2a6ced1273f6">More...</a><br /></td></tr>
<tr class="separator:ga86991d60ebe2ff23303e2a6ced1273f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaed9b1755618770a22bb753ce05ea873a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gaed9b1755618770a22bb753ce05ea873a">rlDriverShiftDWord</a> (rlUInt8_t buf[])</td></tr>
<tr class="memdesc:gaed9b1755618770a22bb753ce05ea873a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Shifts one byte in the byte array.  <a href="#gaed9b1755618770a22bb753ce05ea873a">More...</a><br /></td></tr>
<tr class="separator:gaed9b1755618770a22bb753ce05ea873a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaed4904bfe37ff73389a184d78350bf97"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gaed4904bfe37ff73389a184d78350bf97">rlDriverValidateHdr</a> (<a class="el" href="structrl_prot_header__t.html">rlProtHeader_t</a> protHdr)</td></tr>
<tr class="memdesc:gaed4904bfe37ff73389a184d78350bf97"><td class="mdescLeft">&#160;</td><td class="mdescRight">Validates the header by comparing Checksum.  <a href="#gaed4904bfe37ff73389a184d78350bf97">More...</a><br /></td></tr>
<tr class="separator:gaed4904bfe37ff73389a184d78350bf97"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3c3421e7ea303bb69cf47c4312168dea"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga3c3421e7ea303bb69cf47c4312168dea">rlDriverAsyncEventHandler</a> (rlUInt8_t devIndex, rlUInt16_t nsbc, rlUInt8_t *payload, rlUInt16_t payloadLen)</td></tr>
<tr class="memdesc:ga3c3421e7ea303bb69cf47c4312168dea"><td class="mdescLeft">&#160;</td><td class="mdescRight">Handles asynchronous response/error from mmwave radar device.  <a href="#ga3c3421e7ea303bb69cf47c4312168dea">More...</a><br /></td></tr>
<tr class="separator:ga3c3421e7ea303bb69cf47c4312168dea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga50789ec5f310e9caf5b08b4f43b431fb"><td class="memItemLeft" align="right" valign="top">rlUInt8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga50789ec5f310e9caf5b08b4f43b431fb">rlDeviceIdentifyCmdDir</a> (rlUInt16_t msgId, rlUInt8_t platform)</td></tr>
<tr class="memdesc:ga50789ec5f310e9caf5b08b4f43b431fb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the direction of command packet based on MsgID and platform.  <a href="#ga50789ec5f310e9caf5b08b4f43b431fb">More...</a><br /></td></tr>
<tr class="separator:ga50789ec5f310e9caf5b08b4f43b431fb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad716e6d3b09a31f3b400fc74670a71a0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gad716e6d3b09a31f3b400fc74670a71a0">rlDriverHostIrqHandler</a> (rlUInt8_t deviceIndex, void *pValue)</td></tr>
<tr class="memdesc:gad716e6d3b09a31f3b400fc74670a71a0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Interrupt Service Routine to handle host interrupt from mmwave radar device.  <a href="#gad716e6d3b09a31f3b400fc74670a71a0">More...</a><br /></td></tr>
<tr class="separator:gad716e6d3b09a31f3b400fc74670a71a0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac00a424c2ee45e4473deb91aa4d0ee2b"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gac00a424c2ee45e4473deb91aa4d0ee2b">rlDriverMsgReadCmdCtx</a> (rlUInt8_t devIndex)</td></tr>
<tr class="memdesc:gac00a424c2ee45e4473deb91aa4d0ee2b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait and handle command response.  <a href="#gac00a424c2ee45e4473deb91aa4d0ee2b">More...</a><br /></td></tr>
<tr class="separator:gac00a424c2ee45e4473deb91aa4d0ee2b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7e589b43db2c7090e4e875bc82207b51"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga7e589b43db2c7090e4e875bc82207b51">rlDriverMsgRead</a> (<a class="el" href="structrl_driver_data__t.html">rlDriverData_t</a> *rlDrvData, rlUInt8_t devIndex)</td></tr>
<tr class="memdesc:ga7e589b43db2c7090e4e875bc82207b51"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receive and validate protocol header and payload.  <a href="#ga7e589b43db2c7090e4e875bc82207b51">More...</a><br /></td></tr>
<tr class="separator:ga7e589b43db2c7090e4e875bc82207b51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gace7f1fe6dd048899f8afd3c8a1229f76"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gace7f1fe6dd048899f8afd3c8a1229f76">rlDriverMsgWrite</a> (<a class="el" href="structrl_driver_data__t.html">rlDriverData_t</a> *rlDrvData, rlComIfHdl_t comIfHdl)</td></tr>
<tr class="memdesc:gace7f1fe6dd048899f8afd3c8a1229f76"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write command header and payload data over communication channel.  <a href="#gace7f1fe6dd048899f8afd3c8a1229f76">More...</a><br /></td></tr>
<tr class="separator:gace7f1fe6dd048899f8afd3c8a1229f76"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5060f95e9f242a37c04652bd8fd3214f"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga5060f95e9f242a37c04652bd8fd3214f">rlDriverRxHdrRead</a> (rlUInt8_t hdrBuf[RHCP_HEADER_LEN], rlComIfHdl_t comIfHdl)</td></tr>
<tr class="memdesc:ga5060f95e9f242a37c04652bd8fd3214f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read SYNC and Header from communication channel.  <a href="#ga5060f95e9f242a37c04652bd8fd3214f">More...</a><br /></td></tr>
<tr class="separator:ga5060f95e9f242a37c04652bd8fd3214f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf1f79c99d439cdcd89b4359586449abe"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gaf1f79c99d439cdcd89b4359586449abe">rlDriverFillPayload</a> (rlUInt16_t msgId, rlUInt16_t sbcID, <a class="el" href="structrl_payload_sb__t.html">rlPayloadSb_t</a> *payloadPtr, rlUInt8_t *data, rlUInt16_t inLen)</td></tr>
<tr class="memdesc:gaf1f79c99d439cdcd89b4359586449abe"><td class="mdescLeft">&#160;</td><td class="mdescRight">: Fill payload based on given message-ID, sub-block ID and data.  <a href="#gaf1f79c99d439cdcd89b4359586449abe">More...</a><br /></td></tr>
<tr class="separator:gaf1f79c99d439cdcd89b4359586449abe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga70bb4180f4d2c50e4f98c0c88caf5b11"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga70bb4180f4d2c50e4f98c0c88caf5b11">rlDriverConstructInMsg</a> (rlUInt16_t msgId, <a class="el" href="structrl_driver_msg__t.html">rlDriverMsg_t</a> *inMsg, <a class="el" href="structrl_payload_sb__t.html">rlPayloadSb_t</a> *payloadPtr)</td></tr>
<tr class="memdesc:ga70bb4180f4d2c50e4f98c0c88caf5b11"><td class="mdescLeft">&#160;</td><td class="mdescRight">: Construct command packet (inMsg) based on given message-ID and payload  <a href="#ga70bb4180f4d2c50e4f98c0c88caf5b11">More...</a><br /></td></tr>
<tr class="separator:ga70bb4180f4d2c50e4f98c0c88caf5b11"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3ad7dede6b2335106cb75a4fc42a191f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga3ad7dede6b2335106cb75a4fc42a191f">rlDriverConstructOutMsg</a> (rlUInt16_t numSblk, <a class="el" href="structrl_driver_msg__t.html">rlDriverMsg_t</a> *outMsg, <a class="el" href="structrl_payload_sb__t.html">rlPayloadSb_t</a> *payloadPtr)</td></tr>
<tr class="memdesc:ga3ad7dede6b2335106cb75a4fc42a191f"><td class="mdescLeft">&#160;</td><td class="mdescRight">: Construct command packet based on given message-ID and payload  <a href="#ga3ad7dede6b2335106cb75a4fc42a191f">More...</a><br /></td></tr>
<tr class="separator:ga3ad7dede6b2335106cb75a4fc42a191f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga1038146dd0f9d8fd6caf8ecfad930bec"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga1038146dd0f9d8fd6caf8ecfad930bec">rlDriverProcRdMsg</a> (rlUInt8_t devIdx, rlReturnVal_t inVal)</td></tr>
<tr class="memdesc:ga1038146dd0f9d8fd6caf8ecfad930bec"><td class="mdescLeft">&#160;</td><td class="mdescRight">Process received message for Async event message.  <a href="#ga1038146dd0f9d8fd6caf8ecfad930bec">More...</a><br /></td></tr>
<tr class="separator:ga1038146dd0f9d8fd6caf8ecfad930bec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf2314cb35b3d0061efa9711d64f862a4"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#gaf2314cb35b3d0061efa9711d64f862a4">rlDriverMsgCmdReply</a> (<a class="el" href="structrl_driver_data__t.html">rlDriverData_t</a> *rlDrvData, rlUInt8_t devIndex)</td></tr>
<tr class="memdesc:gaf2314cb35b3d0061efa9711d64f862a4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait and handle command response.  <a href="#gaf2314cb35b3d0061efa9711d64f862a4">More...</a><br /></td></tr>
<tr class="separator:gaf2314cb35b3d0061efa9711d64f862a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0d98a32c9369b06931f54c914e9e2ff2"><td class="memItemLeft" align="right" valign="top">rlReturnVal_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___communication___protocol.html#ga0d98a32c9369b06931f54c914e9e2ff2">rlDriverCmdSendRetry</a> (rlUInt8_t deviceMap, <a class="el" href="structrl_driver_msg__t.html">rlDriverMsg_t</a> *outMsg)</td></tr>
<tr class="memdesc:ga0d98a32c9369b06931f54c914e9e2ff2"><td class="mdescLeft">&#160;</td><td class="mdescRight">: Send command and wait for response  <a href="#ga0d98a32c9369b06931f54c914e9e2ff2">More...</a><br /></td></tr>
<tr class="separator:ga0d98a32c9369b06931f54c914e9e2ff2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>mmwave Communication Driver Module </p>
<p>The mmwave radar Host Communication Driver Module implements the mmwave radar communication protocol:</p><ol type="1">
<li>It is a simple stop and wait protocol. Each message needs to be acknowledged by receiver before next message can be sent.</li>
<li>Messages are classifieds as "Command", "Response" and "Asynchronous Event"</li>
<li>If Command can not be processed immediately, ACK response is sent immediately (If requested). "Asynchronous Event" is sent upon completion of the command execution. </li>
</ol>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga50789ec5f310e9caf5b08b4f43b431fb"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlUInt8_t rlDeviceIdentifyCmdDir </td>
          <td>(</td>
          <td class="paramtype">rlUInt16_t&#160;</td>
          <td class="paramname"><em>msgId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>platform</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the direction of command packet based on MsgID and platform. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">msgId</td><td>- Message ID of data packet </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">platform</td><td>- Platform Type where mmWaveLink instance is running</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlUInt8_t command packet direction</dd></dl>
<p>Returns direction of command packet based on MsgID and platform. </p>

</div>
</div>
<a class="anchor" id="ga01309c1d2f30754b6d5aa89dc1534255"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverAddDevice </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>deviceMap</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Adds mmwave radar device. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">deviceMap</td><td>- Bitmap of device to be connected</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>Adds mmwave radar device Open communication channel, Register Interrupt Handler with device </p>

</div>
</div>
<a class="anchor" id="ga3c3421e7ea303bb69cf47c4312168dea"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverAsyncEventHandler </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>devIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt16_t&#160;</td>
          <td class="paramname"><em>nsbc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt8_t *&#160;</td>
          <td class="paramname"><em>payload</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt16_t&#160;</td>
          <td class="paramname"><em>payloadLen</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Handles asynchronous response/error from mmwave radar device. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">devIndex</td><td>- Device Index </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">nsbc</td><td>- No. of Sub-Block in MSG </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">payload</td><td>- Protocol payload message data </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">payloadLen</td><td>- Length of payload message data</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>Handles asynchronous response/error from mmwave radar device </p>

</div>
</div>
<a class="anchor" id="gadb76873c3994b89f576431bfd4a4322f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverCalCRC </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt16_t&#160;</td>
          <td class="paramname"><em>dataLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>crcType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>crc</em>[RL_CRC_LEN_MAX]&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Calculates 16bit/32bit/64bit CRC. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>- Byte array </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataLen</td><td>- Length of the byte array </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">crcType</td><td>- Type of CRC 16/32/64bit </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">crc</td><td>- Received CRC</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>Calculates 16bit/32bit/64bit CRC </p>

</div>
</div>
<a class="anchor" id="ga3b6ed9a21f83053d4472bfa2dd4edeb3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverCmdInvoke </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>deviceMap</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structrl_driver_msg__t.html">rlDriverMsg_t</a>&#160;</td>
          <td class="paramname"><em>inMsg</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structrl_driver_msg__t.html">rlDriverMsg_t</a> *&#160;</td>
          <td class="paramname"><em>outMsg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Invokes a command to mmwave radar Device. Implements mmwave radar Host Communication Protocol(RHCP) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">deviceMap</td><td>- Bitmap of devices to send the message </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">inMsg</td><td>- Command Opcode(Direction, Class, MsgId) and Subblocks </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">outMsg</td><td>- Response Opcode(Direction, Class, MsgId) and Subblocks</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>Invokes a command to mmwave radar Device. Waits for Response if ACK is requested. Computes CRC/Checksum according to mmwave radar Host Communication Protocol(RHCP) </p>

</div>
</div>
<a class="anchor" id="ga0d98a32c9369b06931f54c914e9e2ff2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverCmdSendRetry </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>deviceMap</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structrl_driver_msg__t.html">rlDriverMsg_t</a> *&#160;</td>
          <td class="paramname"><em>outMsg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>: Send command and wait for response </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">deviceMap</td><td>- device map contains bitmap of all device connected </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">outMsg</td><td>- output msg</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Success : 0, Fail : Error code</dd></dl>
<p>Send command and wait for response </p>

</div>
</div>
<a class="anchor" id="ga84ada376a4dd043625af0c74f5949139"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverConfigureAckTimeout </td>
          <td>(</td>
          <td class="paramtype">rlUInt32_t&#160;</td>
          <td class="paramname"><em>ackTimeout</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Configures the Acknowledgement timeout in mmwavelink Driver. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">ackTimeout</td><td>- ACK timeout, 0 - No ACK</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>Configures the Acknowledgement timeout in mmwavelink Driver </p>

</div>
</div>
<a class="anchor" id="gaad8c54c2f6a875873d3e8d5c4bbb4996"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverConfigureCrc </td>
          <td>(</td>
          <td class="paramtype">rlCrcType_t&#160;</td>
          <td class="paramname"><em>crcType</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Configures the CRC Type in mmwavelink Driver. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">crcType</td><td>- CRC Types</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>Configures the CRC Type in mmwavelink Driver </p>

</div>
</div>
<a class="anchor" id="ga70bb4180f4d2c50e4f98c0c88caf5b11"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void rlDriverConstructInMsg </td>
          <td>(</td>
          <td class="paramtype">rlUInt16_t&#160;</td>
          <td class="paramname"><em>msgId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structrl_driver_msg__t.html">rlDriverMsg_t</a> *&#160;</td>
          <td class="paramname"><em>inMsg</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structrl_payload_sb__t.html">rlPayloadSb_t</a> *&#160;</td>
          <td class="paramname"><em>payloadPtr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>: Construct command packet (inMsg) based on given message-ID and payload </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">msgId</td><td>- message ID of command packet </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">inMsg</td><td>- Message strucutre input pointer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">payloadPtr</td><td>- payload data pointer </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>- none</dd></dl>
<p>Construct Set command packet based on given message-ID and payload </p>

</div>
</div>
<a class="anchor" id="ga3ad7dede6b2335106cb75a4fc42a191f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void rlDriverConstructOutMsg </td>
          <td>(</td>
          <td class="paramtype">rlUInt16_t&#160;</td>
          <td class="paramname"><em>numSblk</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structrl_driver_msg__t.html">rlDriverMsg_t</a> *&#160;</td>
          <td class="paramname"><em>outMsg</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structrl_payload_sb__t.html">rlPayloadSb_t</a> *&#160;</td>
          <td class="paramname"><em>payloadPtr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>: Construct command packet based on given message-ID and payload </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">numSblk</td><td>- number of sub-blocks in message </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">outMsg</td><td>- Message strucutre input pointer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">payloadPtr</td><td>- payload data pointer </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>- none</dd></dl>
<p>Construct Get command packet based on given message-ID and payload </p>

</div>
</div>
<a class="anchor" id="gaaea65220c5b45aa33f34cf850e2525e6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverDeInit </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>De Initializes the mmwave radar Driver. </p>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>DeInitializes the mmwave radar Driver. Clear memory, destroy OS objects, Close communication channel, Unregister Interrupt Handler </p>

</div>
</div>
<a class="anchor" id="gaf1f79c99d439cdcd89b4359586449abe"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void rlDriverFillPayload </td>
          <td>(</td>
          <td class="paramtype">rlUInt16_t&#160;</td>
          <td class="paramname"><em>msgId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt16_t&#160;</td>
          <td class="paramname"><em>sbcID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structrl_payload_sb__t.html">rlPayloadSb_t</a> *&#160;</td>
          <td class="paramname"><em>payloadPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt8_t *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt16_t&#160;</td>
          <td class="paramname"><em>inLen</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>: Fill payload based on given message-ID, sub-block ID and data. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">msgId</td><td>- message ID of command packet </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">sbcID</td><td>- sub block ID of command packet </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">payloadPtr</td><td>- payload data pointer </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">data</td><td>- data pointer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">inLen</td><td>- lenght of data </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>- none</dd></dl>
<p>Fill payload based on given message-ID, sub-block ID and data. </p>

</div>
</div>
<a class="anchor" id="gad308ecd31e0d11005e2726295c713e05"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlDriverGetArDeviceType </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns AR device type which mmWavelink is communicating. </p>
<dl class="section return"><dt>Returns</dt><dd>rlUInt8_t platform</dd></dl>
<p>Returns AR device type which mmWavelink is communicating </p>

</div>
</div>
<a class="anchor" id="ga8e9911b7e730e53f84b06aaa40ed12d2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structrl_driver_data__t.html">rlDriverData_t</a> * rlDriverGetHandle </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns mmwave radar Driver Global Structure. </p>
<dl class="section return"><dt>Returns</dt><dd><a class="el" href="structrl_driver_data__t.html" title="mmwave radar Driver Global Structure ">rlDriverData_t</a> Pointer to mmwave radar Driver Global Structure</dd></dl>
<p>Returns mmwave radar Driver Global Structure </p>

</div>
</div>
<a class="anchor" id="gad528c852d8412ce65b201070852cea98"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlDriverGetPlatformId </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns RL Platform ID (i.e. where mmWaveLink is executing) </p>
<dl class="section return"><dt>Returns</dt><dd>rlUInt8_t platform</dd></dl>
<p>Returns Device run ID (i.e. where mmWaveLink is executing) </p>

</div>
</div>
<a class="anchor" id="gad716e6d3b09a31f3b400fc74670a71a0"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void rlDriverHostIrqHandler </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>deviceIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>pValue</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Interrupt Service Routine to handle host interrupt from mmwave radar device. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">deviceIndex</td><td>- source device Index </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pValue</td><td>- Interrupt Routine Argument</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>none</dd></dl>
<p>Interrupt Service Routine to handle host interrupt from mmwave radar device </p>

</div>
</div>
<a class="anchor" id="gab8128bc740cbb6aea32dc2d0145517fc"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlUInt8_t rlDriverIsDeviceMapValid </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>deviceMap</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Checks if given deviecMap is valid wrt to global DeviceMap set to mmWaveLink. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">deviceMap</td><td>- Bitmap of devices to send the message</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>It enables RF/Analog Subsystem. </p>

</div>
</div>
<a class="anchor" id="gaf2314cb35b3d0061efa9711d64f862a4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverMsgCmdReply </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structrl_driver_data__t.html">rlDriverData_t</a> *&#160;</td>
          <td class="paramname"><em>rlDrvData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>devIndex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Wait and handle command response. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">rlDrvData</td><td>- Pointer to mmWaveLink global structure </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">devIndex</td><td>- Device index of slave device from where response is expected</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>Wait and handle command response </p>

</div>
</div>
<a class="anchor" id="ga7e589b43db2c7090e4e875bc82207b51"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverMsgRead </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structrl_driver_data__t.html">rlDriverData_t</a> *&#160;</td>
          <td class="paramname"><em>rlDrvData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>devIndex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Receive and validate protocol header and payload. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">rlDrvData</td><td>- Pointer to mmwavelink global structure </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">devIndex</td><td>- Device index of slave device from where data is received</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>Receive and validate protocol header and payload </p>

</div>
</div>
<a class="anchor" id="gac00a424c2ee45e4473deb91aa4d0ee2b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverMsgReadCmdCtx </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>devIndex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Wait and handle command response. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">devIndex</td><td>- Device index of slave device from where response is expected</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>Wait and handle command response </p>

</div>
</div>
<a class="anchor" id="gace7f1fe6dd048899f8afd3c8a1229f76"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverMsgWrite </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structrl_driver_data__t.html">rlDriverData_t</a> *&#160;</td>
          <td class="paramname"><em>rlDrvData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlComIfHdl_t&#160;</td>
          <td class="paramname"><em>comIfHdl</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Write command header and payload data over communication channel. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">rlDrvData</td><td>- Pointer to mmwavelink global structure </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">comIfHdl</td><td>- Communication interface handle</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>Write command header and payload data over communication channel </p>

</div>
</div>
<a class="anchor" id="gacaf1e6cb030df5515de84b341558d28c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverOsiInit </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Initializes the OSI layer abstraction for mmwavelink. </p>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>Initializes the OS mutex, semaphore and queue interface for mmwavelink </p>

</div>
</div>
<a class="anchor" id="ga1038146dd0f9d8fd6caf8ecfad930bec"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverProcRdMsg </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>devIdx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlReturnVal_t&#160;</td>
          <td class="paramname"><em>inVal</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Process received message for Async event message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">devIdx</td><td>- device Index </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">inVal</td><td>- status value</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error status</dd></dl>
<p>Process received message for Async event message </p>

</div>
</div>
<a class="anchor" id="ga345ace252f9c3676e09abc0f0b01ad4f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverRemoveDevices </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>deviceMap</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Disconnects the mmwave radar devices. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">deviceMap</td><td>- Bitmap of mmwave devices to be disconnected</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>disconnects the mmwave radar devices Close communication channel, Unregister Interrupt Handler </p>

</div>
</div>
<a class="anchor" id="ga5060f95e9f242a37c04652bd8fd3214f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverRxHdrRead </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>hdrBuf</em>[RHCP_HEADER_LEN], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlComIfHdl_t&#160;</td>
          <td class="paramname"><em>comIfHdl</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Read SYNC and Header from communication channel. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">comIfHdl</td><td>- Communication interface handle </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">hdrBuf</td><td>- Buffer to hold SyncPattern+header information</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t pattern matched type, Failure - Error Code</dd></dl>
<p>Read SYNC and Header from communication channel </p>

</div>
</div>
<a class="anchor" id="gaed9b1755618770a22bb753ce05ea873a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void rlDriverShiftDWord </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>buf</em>[]</td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Shifts one byte in the byte array. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">buf</td><td>- Byte array</td></tr>
  </table>
  </dd>
</dl>
<p>Shifts one byte in the byte array </p>

</div>
</div>
<a class="anchor" id="gaed4904bfe37ff73389a184d78350bf97"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverValidateHdr </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structrl_prot_header__t.html">rlProtHeader_t</a>&#160;</td>
          <td class="paramname"><em>protHdr</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Validates the header by comparing Checksum. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">protHdr</td><td>- Protocol Header</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t Success - 0, Failure - Error Code</dd></dl>
<p>Validates the header by comparing checksum </p>

</div>
</div>
<a class="anchor" id="ga86991d60ebe2ff23303e2a6ced1273f6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverVerifyCRC </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt16_t&#160;</td>
          <td class="paramname"><em>dataLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>crcType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>crc</em>[RL_CRC_LEN_MAX]&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Compares received CRC with Calculated CRC. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>- Byte array </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataLen</td><td>- Length of the byte array </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">crcType</td><td>- Type of CRC 16/32/64bit </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">crc</td><td>- Received CRC</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>rlReturnVal_t CRC Check Pass - 0, CRC Check Fail - RL_RET_CODE_CRC_FAILED</dd></dl>
<p>Compares received CRC with Calculated CRC </p>

</div>
</div>
<a class="anchor" id="ga62c0e0b554649602ff54d2619f368a4d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">rlReturnVal_t rlDriverWaitForResponse </td>
          <td>(</td>
          <td class="paramtype">rlUInt8_t&#160;</td>
          <td class="paramname"><em>devIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structrl_driver_msg__t.html">rlDriverMsg_t</a> *&#160;</td>
          <td class="paramname"><em>outMsg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>: Wait for Device's response </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">devIndex</td><td>- devIndex is index of device not the deviceMap </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">outMsg</td><td>- Driver msg</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Success : 0, Fail : Error code</dd></dl>
<p>Wait for driver response </p>

</div>
</div>
</div><!-- contents -->
<hr size="1"><small>
Copyright  2018, Texas Instruments Incorporated</small>
</body>
</html>
